#!/usr/bin/python
import os
import itertools as it
import cgi
import cgitb
cgitb.enable()

showq = "/opt/maui/bin/showq"

def rowcompressor(t):
    def keyfunc(a):
        numcols = (1, 3)
        columns = a.split()
        key = str()
        if len(columns) > max(numcols):
            for c in numcols:
                key+=columns[c]
        else:
            key = None
        
        return key
    
    ct = list()
    for k,g in it.groupby(t,keyfunc):
        rowgroup = list(g)
        if len(rowgroup) > 5:
            ct.append(rowgroup[0])
            ct.append("         Skipping %s jobs" %(len(rowgroup)-2))
            ct.append(rowgroup[-1])
        else:
            for row in rowgroup:
                ct.append(row)
    return ct

def isjobline(line):
    cells = line.split()
    if not cells or cells[0] in ('ACTIVE', 'IDLE', 'BLOCKED', 'Skipping'):
        return False
    for s in ('Active Jobs', 'Idle Jobs', 'Nodes Active'):
        if s in line:
            return False
    return True
    
def formatline(line, bg, i):
    cells = line.split(None, 5)
    if not cells:
        print "<tr><td>&nbsp;</td></tr>"
        return i
    if not isjobline(line):
        # make the headings a target
        firstword = line.split()[0]
        if firstword in ['ACTIVE', 'IDLE', 'BLOCKED']:
            target = "<a name='%s'> %s </a> <a href='#TOP'>Back to top</a>"%(firstword, line)
        else:
            target = line
        print "<tr><th colspan='5' align='left'> %s </th></tr>"%target
        return i
    
    if cells[0] in ('JOBNAME'):
        celltype = "th"
    else:
        if user == 'All' or user in line:
            celltype = "td"
            # put in a link in to the job detail
            cells[0] = "<a href='./checkjob.cgi?jobid=%s'> %s </a>"%(cells[0], cells[0])
            # make it possible to view jobs from only one user
            cells[1] = "<a href='./showq.cgi?user=%s'> %s </a>"%(cells[1], cells[1])
        else:
            # do not show this job
            return i

    row = "<%s align='left'> %s </%s>"%(celltype, cells[0], celltype)
    for cell in cells[1:]:
        row += "<%s align='right'> %s </%s>"%(celltype, cell, celltype)
    
    print "<tr bgcolor=%s> %s </tr>" % (bg, row)
    return i+1

def filteruser(lines, u):
    if u == "All":
        return lines
        
    filtered_lines = list()
    for l in lines:
        if not isjobline(l):
            filtered_lines.append(l)
        else:
            if u in l:
                filtered_lines.append(l)
    return filtered_lines


form = cgi.FieldStorage()
if form.has_key('user'):
    user = form['user'].value
else:
    user = 'All'

compressjobs = 1
if form.has_key('cj'):
    compressjobs = form['cj'].value


showq_output = os.popen(showq).readlines()

showq_output = filteruser(showq_output, user)

if compressjobs != "0":
    showq_output = rowcompressor(showq_output)


print "Content-Type: text/html"     # HTML is following
print                               # blank line, end of headers
print "<html>"
print "<body BGCOLOR='#FFFFFF'>"
print "<TITLE>showq</TITLE>"
print "<H1><a name='TOP'>Jobs on system</a></H1>"
print "<p><a href='./showstats.cgi'>Statistics</a></p>"
if compressjobs != "0" or user != "All":
    print "<p><a href='./showq.cgi?cj=0'>Show all jobs</a><p>"
else:
    print "<p><a href='./showq.cgi?cj=1'>Show compacted jobs</a><p>"
print "<a href='#ACTIVE'>ACTIVE</a>,<a href='#IDLE'>IDLE</a>,<a href='#BLOCKED'>BLOCKED</a> JOBS"
print "<table>"
bg = ("'#ffffff'", "'#eeeeee'")
i = 0
for line in showq_output:
    i = formatline(line.strip(), bg[i%2], i)

print "</table>"
print "</html>"
print "</body>"
